// src/converters/NumberParam.ts
var NumberParam = {
  serialize: (value) => Number.isFinite(value) ? `${value}` : null,
  deserialize: (value) => {
    try {
      const parsedValue = Number.parseFloat(value);
      return Number.isFinite(parsedValue) ? parsedValue : null;
    } catch {
      return null;
    }
  }
};

// src/converters/ObjectParam.ts
function ObjectParam() {
  return {
    serialize: (value) => encodeURIComponent(JSON.stringify(value)),
    deserialize: (value) => {
      try {
        return JSON.parse(decodeURIComponent(value));
      } catch {
        return null;
      }
    }
  };
}

// src/converters/StringParam.ts
var StringParam = {
  serialize: (value) => value,
  deserialize: (value) => value
};

export {
  NumberParam,
  ObjectParam,
  StringParam
};
//# sourceMappingURL=chunk-HQIGQMD4.mjs.map