import { LocationQueryValue } from 'vue-router';

declare const NumberParam: ParamSerializationConfig<number | null>;

declare function ObjectParam<TObject>(): ParamSerializationConfig<TObject>;

declare const StringParam: ParamSerializationConfig<string | null>;

type ParamSerializationConfig<TParam> = {
    serialize: (value: TParam | null) => LocationQueryValue | LocationQueryValue[];
    deserialize: (value: LocationQueryValue | LocationQueryValue[]) => TParam | null;
};

export { NumberParam, ObjectParam, type ParamSerializationConfig, StringParam };
